Subject: Re: [RFC/RFT, RESEND] powerpc: move cacheinfo sysfs to generic cacheinfo infrastructure

From: Sudeep Holla <[email-masked]>
Date: Tue, 31 Mar 2015 18:14:12 +0100

On 31/03/15 11:56, Michael Ellerman wrote:
> On Mon, 2015-23-02 at 18:18:20 UTC, Sudeep Holla wrote:
>> This patch removes the redundant sysfs cacheinfo code by reusing
>> the newly introduced generic cacheinfo infrastructure through the
>> commit 246246cbde5e ("drivers: base: support cpu cache information
>> interface to userspace via sysfs")
>>
>> Signed-off-by: Sudeep Holla <[email-masked]>
>> Cc: Benjamin Herrenschmidt <[email-masked]>
>> Cc: Paul Mackerras <[email-masked]>
>> Cc: Michael Ellerman <[email-masked]>
>> Cc: Anshuman Khandual <[email-masked]>
>> Cc: [email-masked]
>> ---
>>   arch/powerpc/kernel/cacheinfo.c | 811 +++++-----------------------------------
>>   arch/powerpc/kernel/cacheinfo.h |   8 -
>>   arch/powerpc/kernel/sysfs.c     |  12 +-
>>   3 files changed, 91 insertions(+), 740 deletions(-)
>>   delete mode 100644 arch/powerpc/kernel/cacheinfo.h
>>
>> Hi,
>>
>> This patch is not tested. Last time Anshuman tested, he had seen issues.
>> The core driver has changed a lot after that. Since PPC depends a lot
>> on DT for cache information, there might be issues in the core later
>> which I could not identify with ARM/ARM64. It would be much appreciable
>> if someone help me in testing and fixing those so that PPC can migrate
>> to new/common cacheinfo infrastructure. This resend is rebased on v4.0-rc1
>
> Doesn't build for me.
>
>    arch/powerpc/platforms/pseries/suspend.c:29:36: fatal error: ../../kernel/cacheinfo.h: No such file or directory
>    #include "../../kernel/cacheinfo.h"
>

Right, sorry for missing this. I just tested corenet32_smp_defconfig.
Also after some digging I found that this patch was written before the
commit 6b36ba8492ab (" powerpc/pseries: Update dynamic cache nodes for
suspend/resume operation"). I had a quick looks at that patch and I am
not sure if we can support that with generic cacheinfo implementation.

> Anshuman must have worked around that somehow to test it previously?
>

I think he tried before the above mentioned commit was introduced.

> Removing the include doesn't fix it, it needs cacheinfo_cpu_on/offline().
>

I agree, had a quick look at that, and it requires some rework not sure
if that should be in generic code or ppc specific.

Regards,
Sudeep